/**************************************************************************

	nsc.dll

	prop.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "wwwcdll.h"
#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUFSIZE					256


/******************************************************************************

	AllocGetText

	EDITɐݒ肳ĂTCỸmۂEDIT̓eݒ肷

******************************************************************************/

static void AllocGetText(HWND hEdit, char **buf)
{
	int len;

	if(*buf != NULL){
		GlobalFree(*buf);
	}
	len = SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0) + 1;
	*buf = (char *)GlobalAlloc(LMEM_FIXED, sizeof(char) * (len + 1));
	if(*buf != NULL){
		**buf = '\0';
		SendMessage(hEdit, WM_GETTEXT, len, (LPARAM)*buf);
	}
}


/******************************************************************************

	OptionItemProc

	ACẽvpeB

******************************************************************************/

BOOL CALLBACK OptionItemProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	struct TPITEM *tpItemInfo;
	char *tmp;
	char *p, *r;
	int len;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		tpItemInfo = (struct TPITEM *)lParam;
		if(tpItemInfo == NULL){
			EndDialog(hDlg, FALSE);
			break;
		}

		if(tpItemInfo->Title != NULL && *tpItemInfo->Title != '\0'){
			tmp = (char *)GlobalAlloc(GPTR, lstrlen(tpItemInfo->Title) + lstrlen("̃vpeB") + 1);
			if(tmp != NULL){
				wsprintf(tmp, "%s̃vpeB", tpItemInfo->Title);
			}
			SetWindowText(hDlg, tmp);
			GlobalFree(tmp);

			SendDlgItemMessage(hDlg, IDC_EDIT_TITLE, WM_SETTEXT, 0, (LPARAM)tpItemInfo->Title);
		}else{
			SetWindowText(hDlg, "vpeB");
			SendDlgItemMessage(hDlg, IDC_EDIT_TITLE, WM_SETTEXT, 0, (LPARAM)"VACe");
		}

		SendDlgItemMessage(hDlg, IDC_EDIT_CHECKURL, WM_SETTEXT, 0, (LPARAM)tpItemInfo->CheckURL);
		SendDlgItemMessage(hDlg, IDC_EDIT_VIEWURL, WM_SETTEXT, 0, (LPARAM)tpItemInfo->ViewURL);

		SendMessage(GetDlgItem(hDlg, IDC_EDIT_SIZE), WM_SETTEXT, 0,
			(LPARAM)((tpItemInfo->Size != NULL) ? tpItemInfo->Size : ""));
		SendMessage(GetDlgItem(hDlg, IDC_EDIT_UPDATE), WM_SETTEXT, 0,
			(LPARAM)((tpItemInfo->Date != NULL) ? tpItemInfo->Date : ""));

		//Rg\
		if(tpItemInfo->Comment != NULL){
			SendDlgItemMessage(hDlg, IDC_EDIT_COMMENT, WM_SETTEXT, 0, (LPARAM)tpItemInfo->Comment);
		}
		if(tpItemInfo->ErrStatus != NULL){
			SendDlgItemMessage(hDlg, IDC_EDIT_ERROR, WM_SETTEXT, 0, (LPARAM)tpItemInfo->ErrStatus);
		}
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;

		case IDOK:
			tpItemInfo = (struct TPITEM *)GetWindowLong(hDlg, GWL_USERDATA);
			if(tpItemInfo == NULL){
				EndDialog(hDlg, FALSE);
				break;
			}

			//^Cg
			AllocGetText(GetDlgItem(hDlg, IDC_EDIT_TITLE), &tpItemInfo->Title);

			//`FbNURL
			AllocGetText(GetDlgItem(hDlg, IDC_EDIT_CHECKURL), &tpItemInfo->CheckURL);

			//\URL
			AllocGetText(GetDlgItem(hDlg, IDC_EDIT_VIEWURL), &tpItemInfo->ViewURL);

			//Rg
			len = SendDlgItemMessage(hDlg, IDC_EDIT_COMMENT, WM_GETTEXTLENGTH, 0, 0) + 1;
			tmp = (char *)GlobalAlloc(GPTR, len + 1);
			if(tmp == NULL){
				abort();
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_COMMENT, WM_GETTEXT, len, (LPARAM)tmp);
			if(tpItemInfo->Comment != NULL){
				GlobalFree(tpItemInfo->Comment);
			}
			tpItemInfo->Comment = (char *)GlobalAlloc(GPTR, lstrlen(tmp) + 1);
			if(tpItemInfo->Comment == NULL){
				abort();
			}
			//s̓Xy[Xɕϊ
			for(p = tmp, r = tpItemInfo->Comment;*p != '\0';p++){
				switch(*p){
				case '\r':
					break;

				case '\n':
					*(r++) = ' ';
					break;

				case '\t':
					*(r++) = ' ';
					break;

				default:
					*(r++) = *p;
					break;
				}
			}
			*r = '\0';
			GlobalFree(tmp);

			EndDialog(hDlg, TRUE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}
/* End of source */
