/**************************************************************************

	ns

	script_memory.h

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

#ifndef SCRIPT_MEMORY_H
#define SCRIPT_MEMORY_H

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>


/**************************************************************************
	Define
**************************************************************************/

#ifdef _WIN32_WCE
#ifndef ZeroMemory
#define ZeroMemory(m, size)			memset(m, 0, size)
#endif
#ifndef CopyMemory
#define CopyMemory(t, f, size)		memcpy(t, f, size)
#endif
#endif


/**************************************************************************
	Struct
**************************************************************************/

/**************************************************************************
	Function Prototypes
**************************************************************************/

void *mem_alloc(int size);
void mem_free(void **mem);
char *alloc_copy(const char *buf);
char *alloc_copy_n(char *buf, int size);
char *alloc_join(const char *buf1, const char *buf2);

#endif
/* End of source */
